package bin;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;

import gui.FrontEnd;
import gui.FrontEnd.Mode;

public class GUIApplication extends JPanel implements ActionListener {

	private static final String MAIN_GUI_EVALUATION = "SetEvaluationGUI";
	private static final String MAIN_GUI_EXPERIMENT = "SetExperimentGUI";
	private static final String MAIN_GUI_DIST       = "SetDistGUI";
	private static final String MAIN_EXIT_BUTTON 	= "ExitMainApp";
	
	private FrontEnd currentGUI;
	private JFrame mainFrame;
	
	private static final long serialVersionUID = 1L;

	// public MainApplication(FrontEnd front) {
	public GUIApplication() {
		mainFrame = new JFrame("Ergo-Feeder");
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JMenuBar menuBar = new JMenuBar();
		JMenu fileMenu = new JMenu("File");
		
		JRadioButtonMenuItem evaluationGUI = new JRadioButtonMenuItem("Evaluation-GUI");
		evaluationGUI.setActionCommand(MAIN_GUI_EVALUATION);
		evaluationGUI.addActionListener(this);
		evaluationGUI.setSelected(true);
		
		JRadioButtonMenuItem experimentGUI = new JRadioButtonMenuItem("Experiment-GUI");
		experimentGUI.setActionCommand(MAIN_GUI_EXPERIMENT);
		experimentGUI.addActionListener(this);
		experimentGUI.setSelected(false);
		
		JRadioButtonMenuItem distGUI = new JRadioButtonMenuItem("Distribution-GUI");
		distGUI.setActionCommand(MAIN_GUI_DIST);
		distGUI.addActionListener(this);
		distGUI.setSelected(false);
		
		JMenuItem exitItem = new JMenuItem("Exit");
		exitItem.setActionCommand(MAIN_EXIT_BUTTON);
		exitItem.addActionListener(this);
		
		fileMenu.add(evaluationGUI);
		fileMenu.add(experimentGUI);
		fileMenu.add(distGUI);
		fileMenu.addSeparator();
		fileMenu.add(exitItem);
		
		menuBar.add(fileMenu);
		
		mainFrame.setJMenuBar(menuBar);
		
		ButtonGroup guiButtons = new ButtonGroup();
		guiButtons.add(evaluationGUI);
		guiButtons.add(experimentGUI);
		guiButtons.add(distGUI);
		
		currentGUI = new FrontEnd(Mode.EVALUATION_MODE);

		mainFrame.add(currentGUI);
		mainFrame.setVisible(true);

		// mainFrame.setExtendedState(Frame.MAXIMIZED_BOTH);
		mainFrame.setSize(800, 600);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Main method
		/*MainApplication app = */new GUIApplication();
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	@Override
	public void actionPerformed(ActionEvent event) {
		if (event.getActionCommand().equals(MAIN_GUI_EVALUATION)) {
			mainFrame.remove(currentGUI);
			currentGUI = new FrontEnd(Mode.EVALUATION_MODE);
			mainFrame.add(currentGUI);
			mainFrame.validate();
		} else if (event.getActionCommand().equals(MAIN_GUI_EXPERIMENT)) {
			mainFrame.remove(currentGUI);
			currentGUI = new FrontEnd(Mode.EXPERIMENT_MODE);
			mainFrame.add(currentGUI);
			mainFrame.validate();
		} else if (event.getActionCommand().equals(MAIN_GUI_DIST)) {
			mainFrame.remove(currentGUI);
			currentGUI = new FrontEnd(Mode.DIST_MODE);
			mainFrame.add(currentGUI);
			mainFrame.validate();
		} else if (event.getActionCommand().equals(MAIN_EXIT_BUTTON)) {
			System.exit(0);
		}
	}
}
