package bin;

import org.cybergarage.upnp.Device;
import org.cybergarage.upnp.device.InvalidDescriptionException;

import util.Runner;

public class UPnPApplication {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String filename = "upnpdata/devicedescription.xml";
		Device upnpDev = null;
		//UPnP.initialize();
		try {
			upnpDev = new Device(filename);
			Runner.upnpDev = upnpDev;
			Runner listener = new Runner();
			upnpDev.setActionListener(listener);
			upnpDev.setQueryListener(listener);
			upnpDev.start();
			System.err.println("Started UPnP listening on " + upnpDev.getInterfaceAddress() + ":" + upnpDev.getHTTPPort());
		} catch (InvalidDescriptionException e) {
			System.err.println("Description file invalid: " + e.getMessage());
		}
		
		GUIApplication app = new GUIApplication();
		while(app.isVisible()) {
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		if (upnpDev != null) {
			upnpDev.stop();
		}
	}

}
